aboutsummaryrefslogtreecommitdiffstats
path: root/test/suite-decryption.sh
diff options
context:
space:
mode:
authorSimon Graham <simgrxp@gmail.com>2017-07-04 10:38:24 -0400
committerMichael Mann <mmann78@netscape.net>2017-07-09 18:25:08 +0000
commitffb8bbd37227f466d228f20ae30b87504d4e1760 (patch)
tree6628b2a5c6a2bae4ea11efe5d79d724863a9af65 /test/suite-decryption.sh
parent723c76b12c0ceaf32dfa4d65e3da6f0c2905a2db (diff)
Add support for dissecting UDT over DTLS
Includes adding per-conversation data to store whether we are over DTLS or UDP and registering as a heuristic sub-dissector for DTLS. Future changes will add more use of the conversation structure. Also included is a capture of UDT over DTLS in test/captures/udt-dtls.pcapng.gz, the associated private key for the session in test/keys/udt-dtls.key and a new test in the decryption suite to check this works. Change-Id: I76826d3b35768d0b58f5335063884616968e5784 Reviewed-on: https://code.wireshark.org/review/22533 Reviewed-by: Peter Wu <peter@lekensteyn.nl> Petri-Dish: Peter Wu <peter@lekensteyn.nl> Tested-by: Petri Dish Buildbot <buildbot-no-reply@wireshark.org> Reviewed-by: Michael Mann <mmann78@netscape.net>
Diffstat (limited to 'test/suite-decryption.sh')
-rwxr-xr-xtest/suite-decryption.sh20
1 files changed, 20 insertions, 0 deletions
diff --git a/test/suite-decryption.sh b/test/suite-decryption.sh
index a5774708a8..8f81812252 100755
--- a/test/suite-decryption.sh
+++ b/test/suite-decryption.sh
@@ -176,6 +176,25 @@ decryption_step_dtls_psk_aes128ccm8() {
test_step_ok
}
+# UDT over DTLS 1.2 with RSA key
+decryption_step_udt_dtls() {
+ TEST_KEYS_FILE="$TESTS_DIR/keys/udt-dtls.key"
+ if [ "$WS_SYSTEM" == "Windows" ] ; then
+ TEST_KEYS_FILE="`cygpath -w $TEST_KEYS_FILE`"
+ fi
+ $TESTS_DIR/run_and_catch_crashes env $TS_DC_ENV $TSHARK $TS_DC_ARGS \
+ -o dtls.keys_list:"0.0.0.0,0,data,$TEST_KEYS_FILE" \
+ -Y "dtls && udt.type==ack" \
+ -r "$CAPTURE_DIR/udt-dtls.pcapng.gz" \
+ | grep UDT > /dev/null
+ RETURNVALUE=$?
+ if [ ! $RETURNVALUE -eq $EXIT_OK ]; then
+ test_step_failed "Failed to decrypt UDT/DTLS using the server's RSA private key"
+ return
+ fi
+ test_step_ok
+}
+
# IPsec ESP
# https://bugs.wireshark.org/bugzilla/show_bug.cgi?id=12671
decryption_step_ipsec_esp() {
@@ -633,6 +652,7 @@ tshark_decryption_suite() {
test_step_add "IEEE 802.11 WPA TDLS Decryption" decryption_step_80211_wpa_tdls
test_step_add "DTLS Decryption" decryption_step_dtls
test_step_add "DTLS 1.2 Decryption (PSK AES-128-CCM-8)" decryption_step_dtls_psk_aes128ccm8
+ test_step_add "UDT over DTLS 1.2 Decryption" decryption_step_udt_dtls
test_step_add "IPsec ESP Decryption" decryption_step_ipsec_esp
test_step_add "SSL Decryption (private key)" decryption_step_ssl
test_step_add "SSL Decryption (RSA private key with p smaller than q)" decryption_step_ssl_rsa_pq